unit hiSQLite_QueryScalar;

interface

uses
  Kol, Share, Debug, SqLite3Api;

type
  THISQLite_QueryScalar = class(TDebug)
    private
      FResult: string; 
    public
      _prop_SQL: string;
      _prop_Charset: Byte;

      _data_SQL: THI_Event;
      _data_dbHandle: THI_Event;
      _event_onError: THI_Event;
      _event_onQuery: THI_Event;

      procedure _work_doQuery(var _Data: TData; Index: Word);
      procedure _work_doCharset(var _Data: TData; Index: Word);
      procedure _var_Result(var _Data: TData; Index: Word);
  end;

implementation

uses
  hiSQLite_DB, hiCharset;

function callback(user: Pointer; ncols: Integer; values: PCharPointers; names: PCharPointers): Integer; cdecl;
var
  S: AnsiString;
begin
  S := AnsiString(values[0]);
  if THISQLite_QueryScalar(user)._prop_Charset = 1 then  S := UTF8ToString(S); //  UTF-8
  
  THISQLite_QueryScalar(user).FResult := S;
  
  Result := 0;
end;

procedure THISQLite_QueryScalar._work_doQuery;
var
  id: Pointer;
  msg: PAnsiChar;
  s: string;
begin
  FResult := '';
  id := ReadObject(_Data, _data_dbHandle, SQLite_GUID);
  s := ReadString(_Data, _data_SQL, _prop_SQL);
  if id <> nil then
  begin
    if _prop_Charset = 1 then s := StringToUTF8(s); //  UTF-8
    sqlite3_exec(id, PAnsiChar(s), callback, self, @msg);
    
    if msg <> nil then
    begin
      _hi_CreateEvent(_Data, @_event_onError, string(msg));
      sqlite3_free(msg);
    end
    else
      _hi_CreateEvent(_Data, @_event_onQuery, FResult);
  end;
end;

procedure THISQLite_QueryScalar._work_doCharset;
begin
  _prop_Charset := ToInteger(_Data);
end;

procedure THISQLite_QueryScalar._var_Result;
begin
  dtString(_Data, FResult);
end;

end.
